import 'dart:async';
import 'dart:math';
import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:login_screen/bottomnavigationbar/page1.dart';
import 'package:login_screen/bottomnavigationbar/page2.dart';
import 'package:login_screen/bottomnavigationbar/page3.dart';
import 'package:login_screen/bottomnavigationbar/page4.dart';

class FlyingIcon {
  double size;
  double xposition;
  double yposition;
  double endyposition;
  double speed;
  Color color;
  FlyingIcon(this.size, this.xposition, this.yposition,this.endyposition, this.speed, this.color);
}


class NavBar10 extends StatefulWidget {
  const NavBar10({Key? key}) : super(key: key);

  @override
  State<NavBar10> createState() => _NavBar10State();
}

class _NavBar10State extends State<NavBar10> with TickerProviderStateMixin{
  List<FlyingIcon> newIcons = [];
  late final AnimationController _controller=AnimationController(
    vsync: this,
    duration: const Duration(seconds: 1),
  );
  int _selectedIndex = 0;
  List pages = [
    const Page1(),
    const Page2(),
    const Page3(),
    const Page4(),
  ];
List labes=[
  'Player',
  'Songs',
  'Artists',
  'Profile'
];

  List icon=[
    Icons.play_circle,
    Icons.music_note,
    Icons.article,
    Icons.person
  ];
  void onTapNav(int index) {
    setState(() {
      _selectedIndex = index;
    });
  }

  void startIconFly() {
    Timer.periodic(Duration(milliseconds: 600), (timer) {
      double size = Random().nextInt(10)+20; // Random size between 20 and 70
      double xposition = MediaQuery.of(context).size.height-40;
      double yposition = -10;
      double endyposition = (Random().nextDouble() * 2 - 1) * 20;
      double speed = Random().nextDouble()+1;
      Color color= Color.fromARGB(
        255,
        Random().nextInt(256),
        Random().nextInt(256),
        Random().nextInt(256),
      );// Random speed between 100 and 300
      FlyingIcon newIcon = FlyingIcon(size, xposition, yposition,endyposition, speed, color);
      setState(() {
        newIcons.add(newIcon);
      });
      flyIcon(newIcon, timer);
    });
  }

  void flyIcon(FlyingIcon flyingIcon, Timer timer) {
    double lastLimit = MediaQuery.of(context).size.width +20;
    double maxHeight = MediaQuery.of(context).size.height -70;
    Timer.periodic(const Duration(milliseconds: 16), (timer) {
      setState(() {
        flyingIcon.yposition += flyingIcon.speed;
        if (flyingIcon.xposition > maxHeight) {
          flyingIcon.xposition += flyingIcon.endyposition * 0.007;
        }
      });

      if (flyingIcon.yposition > lastLimit) {
        setState(() {
          newIcons.remove(flyingIcon);
        });
        timer.cancel();
      }
    });
  }


  @override
  void initState() {
    super.initState();
    startIconFly();
    SystemChrome.setSystemUIOverlayStyle(const SystemUiOverlayStyle(statusBarColor: Colors.transparent,statusBarIconBrightness: Brightness.light,));
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    Size screenSize = MediaQuery.of(context).size;
    return Scaffold(
      body: Stack(
        children: [
          Container(
            height: screenSize.height,
            width: screenSize.width,
            decoration: const BoxDecoration(
              gradient: LinearGradient(
                begin: Alignment.topLeft,
                end: Alignment.bottomRight,
                colors: [
                  Colors.indigo,
                  Colors.greenAccent,

                ]
              )
            ),
          ),
          pages[_selectedIndex],
          Stack(
            children: [
              Stack(
                children:
                newIcons.map((icon) {
                  return Positioned(
                    top: icon.xposition,
                    left: icon.yposition,
                    child: Icon(Icons.music_note,size: icon.size,color: icon.color,)
                  );
                }).toList(),
              ),
              Positioned(
                bottom: 0,
                child: SizedBox(
                  width: screenSize.width,
                  height: 70,
                  child: Container(
                   decoration: BoxDecoration(
                     gradient: LinearGradient(
                       begin: Alignment.bottomCenter,
                       end: Alignment.topCenter,
                       colors: [
                         Colors.green.withOpacity(.7),
                         Colors.white70.withOpacity(.1)
                       ]
                     )
                   ),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceAround, // Distribute items evenly
                      children: List.generate(
                        labes.length,
                            (index) {
                          return InkWell(
                            onTap: (){
                              onTapNav(index);
                            },
                            child: SizedBox(

                              width: screenSize.width/4,
                              child: Column(
                                mainAxisAlignment: MainAxisAlignment.center,
                                children: [
                                  Icon(icon[index],color: _selectedIndex==index?Colors.deepPurple.shade800:Colors.deepPurple,size: _selectedIndex==index?35:20,),
                                  const SizedBox(height: 5), // Add spacing between icon and text
                                  Text('${labes[index]}',style: TextStyle(
                                      color: _selectedIndex==index?Colors.deepPurple.shade700:Colors.deepPurple.shade400,
                                      fontSize: _selectedIndex==index?14:20
                                  ),),
                                ],
                              ),
                            ),
                          );
                        },
                      ),
                    ),
                  ),
                ),
              ),
            ],
          ),
        ],
      ),

    );
  }


}
