import 'package:flutter/material.dart';

class Page3 extends StatefulWidget {
  const Page3({Key? key}) : super(key: key);

  @override
  State<Page3> createState() => _Page3State();
}

class _Page3State extends State<Page3> {
  @override
  Widget build(BuildContext context) {
    Size scrSize=MediaQuery.of(context).size;
    return Scaffold(
        backgroundColor: Colors.transparent,
        body: Container(
          padding: EdgeInsets.symmetric(horizontal: 20,vertical: 70),

          child: GridView.builder(
            itemCount: 20,
              shrinkWrap: true,
              gridDelegate: const SliverGridDelegateWithMaxCrossAxisExtent(
                  maxCrossAxisExtent: 250,
                  childAspectRatio: 2 / 3.6,
                  crossAxisSpacing: 15,
                  mainAxisSpacing: 15),
              itemBuilder: (context,index){
                return ClipRRect(
                  borderRadius: BorderRadius.circular(20),
                  child: Container(
                    padding: EdgeInsets.symmetric(vertical: 10,horizontal: 10),
                    decoration: BoxDecoration(
                      gradient: LinearGradient(
                          begin: Alignment.bottomCenter,
                          end: Alignment.topCenter,
                          colors: [
                            Colors.white70.withOpacity(.6),
                            Colors.white70.withOpacity(.2)
                          ]
                      )
                    ),
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.spaceAround,
                      children: [
                        ClipRRect(
                            borderRadius: BorderRadius.circular(10),
                            child: Image(image: AssetImage('assets/background/1.jpg'),fit: BoxFit.cover,)),
                        Text('Artist Name',style: TextStyle(fontSize: 16,color: Colors.deepPurple,overflow: TextOverflow.ellipsis),maxLines: 2,)
                      ],
                    ),
                  ),
                );
              }),
        )
    );
  }
}
